﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.UltraChart.Resources.Appearance;
using Infragistics.UltraChart.Core;
using Infragistics.UltraChart.Core.Primitives;
using Infragistics.UltraChart.Shared.Styles;
using System.Diagnostics;

namespace WinChartLineChart
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Random rnd = new Random();
            NumericSeries ser = new NumericSeries();
            for (int i = 0; i < 17; i++)
            {
                NumericDataPoint point = new NumericDataPoint(rnd.Next(4000, 20000), "Label" + i.ToString(), false);
                ser.Points.Add(point);
            }
            ultraChart1.LineChart.ChartComponent.Series.Add(ser);
            
        }


        private void ultraChart1_FillSceneGraph(object sender, Infragistics.UltraChart.Shared.Events.FillSceneGraphEventArgs e)
        {
            IAdvanceAxis xAxis = e.Grid["X"] as IAdvanceAxis;
            IAdvanceAxis yAxis = e.Grid["Y"] as IAdvanceAxis;

            if (xAxis == null || yAxis == null)
                return;
            int xNow = (int)xAxis.Map(10);
            int yMin = (int)yAxis.MapMinimum;
            int yMax = (int)(yAxis.MapMaximum * 2);
            Point bottom = new Point(xNow, yMin);
            Point top = new Point(xNow, yMax);
            Line myLine = new Line(bottom, top);
            top.Offset(-12, 0);

            Box b = new Box(top, 25, 60);
            //b.RotationAngle = 90;
            b.PE.Fill = Color.Firebrick;

            LabelStyle labelStyle = new LabelStyle(new System.Drawing.Font("Arial", 10), Color.Black, false, true, true, StringAlignment.Near, StringAlignment.Far, TextOrientation.VerticalLeftFacing);
            Text t = new Text(top, "2010", labelStyle);

            e.SceneGraph.Add(myLine);
            e.SceneGraph.Add(b);
            e.SceneGraph.Add(t);



        }

        private void ultraChart1_ChartDrawItem(object sender, Infragistics.UltraChart.Shared.Events.ChartDrawItemEventArgs e)
        {
            //Alingn X labels
            if (e.Primitive is Text && e.Primitive.Path == "Border.Title.Grid.X")
            {
                ((Text)e.Primitive).bounds.Y = ultraChart1.Size.Height - 120;
                ((Text)e.Primitive).labelStyle.HorizontalAlign = StringAlignment.Near;
            }
            //Alingn Y labels
            if (e.Primitive is Text && e.Primitive.Path == "Border.Title.Grid.Y")
            {
                ((Text)e.Primitive).bounds.X = ultraChart1.Left + 50;
                ((Text)e.Primitive).labelStyle.HorizontalAlign = StringAlignment.Near;
            }
        }
    }
}
